signature Tree = 
sig
  datatype 'a Tree = Leaf | Node of 'a * 'a Tree * 'a Tree;

  val insert: ('a*'a -> order) -> 'a * 'a Tree -> 'a Tree;
  
  val ListToTree: ('a*'a -> order) -> 'a list -> 'a Tree;


  val inOrder: 'a Tree -> 'a list;
  val preOrder: 'a Tree -> 'a list;
  val postOrder: 'a Tree -> 'a list;
  val sort: ('a*'a -> order) -> 'a list -> 'a list;  

  val dontRemove: ('a*'a -> order) -> 'a*'a -> order;
end;