(**********************************************)
(* Eksamensst dec.1998                       *)
(**********************************************)

(* Opgave 1 *)
type vareBesk = string;
type pris = int;
type vareKatalog = (vareBesk * pris) list;

val bilKatalog = [("Alfa Romeo GTV 3.0 V6",500000),
		  ("Alfa Romeo Shigera",20000000),
		  ("Alfa Romeo Spider 3.0 V6",525000),
		  ("Alfa Romeo 156 2.5 V6",410000),
		  ("Audi TT 2.8",1200000),
		  ("Aston Martin DB7",1800000),
		  ("Bentley Hunaudieres 8.0 V16",35000000),
		  ("BMW Nasca C2",4000000),
		  ("BMW Z3 3.0 R6",1500000),
		  ("BMW Z8 3.0 R6",1800000),
		  ("Bugatti Chiron",5999995),
		  ("Bugatti EB110",5000000),
		  ("Chevrolet Corvette Z1",850000),
		  ("Chevrolet Corvette 1956",400000),
		  ("Chrysler Viper Venom",2200000),
		  ("Citroen 2CV",45000),
		  ("Ellert",8000),
                  ("Ferrari Dino",850000),
		  ("Ferrari F310 B",69999995),
		  ("Ferrari F50",8000000),
		  ("Ferrari Testarossa",3500000),
		  ("Ferrari 355 Spider",3700000),
		  ("Ferrari 360 Modena",3000000),
		  ("Ferrari 550 Maranello",4000000),
		  ("FIAT Punto Cabriolet",129995),
		  ("Ford GT90",5000000),
		  ("Healy 100 6",300000),
		  ("Jaguar Type E",700000),
		  ("Jaguar XJR-15 group 6 racer",22000000),
		  ("Jaguar XJ220",12000000),
		  ("Koenig Competition Evolution",14999995),
		  ("Lamborghini Cala",5000000),
		  ("Lamborghini Countach",2900000),
		  ("Lamborghini Diablo",4500000),
		  ("Lamborghini Diablo Roadster",5000000),
		  ("Lamborghini Diablo VT",4900000),
		  ("Lancia Stratos",560000),
		  ("Lotus Elang",1200000),
		  ("Lotus Elise",330000),
		  ("Lotus Esprit 4.0 V8",2300000),
		  ("Lotus Super Seven",750000),
		  ("Mercedes CLK GTR",32000000),
		  ("Mercedes SLK Coupe Brabus 7.2",8000000),
		  ("Mercedes SLR",7000000),
		  ("Mercedes SLR Roadster",7500000),
		  ("McLaren F1",27999000),
		  ("McLaren F1 LM",30000000),
		  ("Morris Mascot",70000),
		  ("Morris 1000",100000),
		  ("Porsche Boxster",850000),
		  ("Porsche GT1",24000000),
		  ("Porsche 356",220000),
		  ("Porsche 911 Turbo 1999",1800000),
		  ("Renault 5",21000),
		  ("Spectre R42",3000000),
		  ("Subaru Impreza",330000),
		  ("TVR Cerbera",950000),
		  ("TVR Chimaera",1000000),
		  ("TVR Speed 12",11999000),
		  ("Trabant",13000),
		  ("Vector",12000000),
		  ("Velocipiede -3 hjul",299),
		  ("Venturi Trophy",4500000),
		  ("VW New Beetle",280000),
		  ("Williams Formula 1",45000000)];

val extraKatalog = [("Ratplys",100),
		    ("Plysterninger",58),
		    ("Diskokugle",35),
		    ("Servostyring",50000),
		    ("Alu-flge Racer",40000),
		    ("Alu-flge Sport",20000),
		    ("Alu-flge HiSpeed",25000),
		    ("Alu-flge Le Mans",30000),
		    ("Trd-flge, chrom",18000),
		    ("Dk < 200 km/t",800),
		    ("Dk < 250 km/t",2000),
		    ("Kvalitetsdk < 250 km/t",4000),
		    ("Dk < 270 km/t",8000),
		    ("Dk < 270 km/t, lavprofil",12000),
		    ("Dk > 270 km/t",16000),
		    ("Vinterdk",800),
		    ("Vinterdk Sport",2000),
		    ("Aircondition til limousine",15000),
		    ("Aircondition til sportsvogn",12000),
		    ("ABS",15000),
		    ("ABS HiSpeed",20000),
		    ("Hkspoiler (afhngig af bilmodel)",15000),
		    ("Tgelygter",2000),
		    ("Lderindtrk",35000),
		    ("Wunderbaum",20),
		    ("Ferrari isskraber",250),
		    ("Streamers, stort udvalg",150),
		    ("Elruder",12000),
		    ("Garfield i plys m. sugekopper",200),
		    ("Nakkesttte m. Sony Playstation",35000),
		    ("Radio m. bndspiller",700),
		    ("Radio RDS m. bndspiller",1200),
		    ("Radio m. CD-afspiller",1400),
		    ("Radio RDS m. CD-afspiller",4000),
		    ("Radio RDS m. CD-afspiller, 7 stk. omskifter",7000),
		    ("Radio RDS m. CD-afspiller, 7 stk. omskifter og GSM",14000),
		    ("Centralls",5000),
		    ("Alu-gearknop",100),
		    ("Semi-automatisk gear",70000),
		    ("Hjttalerst, 40W",500),
		    ("Hjttalerst, 60W",700),
		    ("Hjttalerst, 80W",1200),
		    ("Hjttalerst, 100W + subwoofer",3800),
		    ("Startsprre",2000),
		    ("Alarmst, komplet m. startsprre",12000)];

val udeluk = [("Plysterninger","Diskokugle"),
	      ("Plysterninger","Wunderbaum"),
	      ("Diskokugle","Wunderbaum"),
	      ("Alu-flge Racer","Alu-flge Sport"),
	      ("Alu-flge Racer","Alu-flge HiSpeed"),
	      ("Alu-flge Racer","Alu-flge Le Mans"),
	      ("Alu-flge Racer","Trd-flge, chrom"),
	      ("Alu-flge Sport","Alu-flge HiSpeed"),
	      ("Alu-flge Sport","Alu-flge Le Mans"),
	      ("Alu-flge Sport","Trd-flge, chrom"),
	      ("Alu-flge HiSpeed","Alu-flge Le Mans"),
	      ("Alu-flge HiSpeed","Trd-flge, chrom"),
	      ("Alu-flge Le Mans","Trd-flge, chrom"),
	      ("Dk < 200 km/t","Dk < 250 km/t"),
	      ("Dk < 200 km/t","Kvalitetsdk < 250 km/t"),
	      ("Dk < 200 km/t","Dk < 270 km/t"),
	      ("Dk < 200 km/t","Dk < 270 km/t, lavprofil"),
	      ("Dk < 200 km/t","Dk > 270 km/t"),
	      ("Dk < 250 km/t","Kvalitetsdk < 250 km/t"),
	      ("Dk < 250 km/t","Dk < 270 km/t"),
	      ("Dk < 250 km/t","Dk < 270 km/t, lavprofil"),
	      ("Dk < 250 km/t","Dk > 270 km/t"),
	      ("Kvalitetsdk < 250 km/t","Dk < 270 km/t"),
	      ("Kvalitetsdk < 250 km/t","Dk < 270 km/t, lavprofil"),
	      ("Kvalitetsdk < 250 km/t","Dk > 270 km/t"),
	      ("Dk < 270 km/t","Dk < 270 km/t, lavprofil"),
	      ("Dk < 270 km/t","Dk > 270 km/t"),
	      ("Dk < 270 km/t, lavprofil","Dk > 270 km/t"),
	      ("Vinterdk","Vinterdk Sport"),
	      ("Aircondition til limousine","Aircondition til sportsvogn"),
	      ("ABS","ABS HiSpeed"),
	      ("Radio m. bndspiller","Radio RDS m. bndspiller"),
	      ("Radio m. bndspiller","Radio m. CD-afspiller"),
	      ("Radio m. bndspiller","Radio RDS m. CD-afspiller"),
	      ("Radio m. bndspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter"),
	      ("Radio m. bndspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter og GSM"),
	      ("Radio RDS m. bndspiller","Radio m. CD-afspiller"),
	      ("Radio RDS m. bndspiller","Radio RDS m. CD-afspiller"),
	      ("Radio RDS m. bndspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter"),
	      ("Radio RDS m. bndspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter og GSM"),
	      ("Radio m. CD-afspiller","Radio RDS m. CD-afspiller"),
	      ("Radio m. CD-afspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter"),
	      ("Radio m. CD-afspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter og GSM"),
	      ("Radio RDS m. CD-afspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter"),
	      ("Radio RDS m. CD-afspiller","Radio RDS m. CD-afspiller, 7 stk. omskifter og GSM"),
	      ("Radio RDS m. CD-afspiller, 7 stk. omskifter","Radio RDS m. CD-afspiller, 7 stk. omskifter og GSM"),
	      ("Hjttalerst, 40W","Hjttalerst, 60W"),
	      ("Hjttalerst, 40W","Hjttalerst, 80W"),
	      ("Hjttalerst, 40W","Hjttalerst, 100W + subwoofer"),
	      ("Hjttalerst, 60W","Hjttalerst, 80W"),
	      ("Hjttalerst, 60W","Hjttalerst, 100W + subwoofer"),
	      ("Hjttalerst, 80W","Hjttalerst, 100W + subwoofer"),
	      ("Startsprre","Alarmst, komplet m. startsprre")];

fun count[] = 0
 | count(x::xs) = 1 + count(xs);

fun name[] = []
 | name((s,i)::rest) = s::name(rest);


(* a: findPris: vareBesk * vareKatalog -> pris, locate vareBesk in vareKatalog *)
fun findPris( _, [] ) = 0.0
 |  findPris( vb, (v,p)::vk ) = if v=vb then p else findPris(vb, vk);

type extra = vareBesk * pris;
type salg = vareBesk * extra list;

(* b: salgsPris: salg * vareKatalog -> pris *)
fun salgsPris( (hovedvare,[]), vk ) = findPris(hovedvare, vk)
 |  salgsPris( (hovedvare,e::el), vk ) = findPris(e, vk)+salgsPris( (hovedvare,el),vk);

(* c: extraOk: extra list * udelukker -> bool *)
type udelukker = (vareBesk * vareBesk) list;

local
    (* kan vi have dette par? extra*extra * udelukker -> bool *)
    fun canDo( _, [] ) = true
     |  canDo( (a,b), (aa,bb)::ul ) = if ((a=aa) andalso (b=bb)) orelse ((a=bb) andalso (b=aa)) then false else canDo( (a,b), ul )
    fun canDoList( e, [], ul ) = true
     |  canDoList( e, f::fl, ul ) = canDo((e,f),ul) andalso canDoList(e,fl,ul)
in
    fun extraOk( [], _ ) = true
     |  extraOk( e::el, ul ) = if not (canDoList(e,el,ul)) then false else extraOk(el,ul)
end;

(* Opgave 2 *)
(* a *)
fun trip( [],_,_ ) = []
 |  trip( _,[],_ ) = []
 |  trip( _,_,[] ) = []
 |  trip(x::xl,y::yl,z::zl) = (x,y,z)::trip(xl,yl,zl);

fun trap( [] ) = ([],[],[])
 |  trap( (x,y,z)::xyzl ) = 
    let 
	val (xl,yl,zl) = trap( xyzl )
    in
	(x::xl, y::yl, z::zl)
    end;

(* b *)
(*
trip: 'a list * 'b list * 'c list -> ('a * 'b * 'c) list
trap: ('a * 'b * 'c) list -> 'a list * 'b list * 'c list 
*)

(* c *)
fun trap2(xyzs) = foldr (fn ((x,y,z),(xl,yl,zl)) => (x::xl,y::yl,z::zl) ) ([],[],[]) (xyzs)



(* Opgave 3 *)
(* a *)

(*
  h op+ 0 [1,2,3,4] => 0::(h op+ 1 [2,3,4]) => 0::(1+0::(h op+ 3 [3,4]) => 0::(1::(3::(6::10) = [0,1,3,6,10]
  h op- 0 [1,2,3,4] => 0::(h op- 1 [2,3,4]) => 0::(1::(h op- 1 [3,4])) => ... => ..::(1::(h op- 2 [4]) => [0,1,1]::2::(h op- 2 []) => [0,1,1,2,2]
*)

(* b *)
(*

h: ('b * 'a -> 'a) -> 'a -> 'b list -> 'a list

 f: 'b * 'a -> 'a

in: 'b list 
out 'a list

ofte brugt mnster:
                        parametren(her ([]))
                         +------+  +-----+ output (her [a])
h: ( _ * _ -> _ ) -> _ -> _ list -> _ list
                    +-+ 
                    (her a)
   +-------------+
    selve higher-order funktionen (her f)
 

h: ( 'a * 'b -> 'b ) -> 'b -> 'a list -> 'b list

h: 'a -> 'b (alle funktioners type)
   'a list -> 'b list (pga input-struktur og output struktur)
   ( ''a -> ''b ) -> ''c -> 'a list -> 'b list  (pga higher-order og alle funktionstyper)
   ( '''a * '''b -> '''c ) -> 'b -> 'a list -> 'b list (pga higher-order tager tuple og at ''c skal vre element i output-listen)
   ( '''a * '''b -> 'b ) -> 'b -> 'a list -> 'b list (da output fra H-O er element i output-listen)
   ( 'a * 'b -> 'b ) -> 'b -> 'a list -> 'b list (da '''b er ved "f(x,a)" lig med 'b og ved samme at '''a='a da x er element i input)
*)

fun h f a ([]) = [a]
 |  h f a (x::xs) = a::(h f (f(x,a)) (xs) );

(*
   x1 til xk for at danne yk.
   det gres ved at lave
       foldl (fn (a,b) => f(a,b) ) a ( [x1 til xk] )


  h f a [1,2] => a::(h f f(1,a) [2]) => a::(f(1,a)::(h f f(2,f(1,a)) []) => a::f(1,a)::f(2,f(1,a))
*)

(* Opgave 4 *)

infix Add
datatype udtr = Const of int | Var of string | Add of udtr * udtr

infix SAdd
datatype skab = SConst of int | SVar of string | SAdd of skab * skab

val skab1 = SConst(10) SAdd ((SVar("a") SAdd SVar("b")) SAdd (SVar("c") SAdd SVar("d")))
(* a *)

(* fun vars: skab -> string list *)

fun vars(x) = 
    case x of
	SConst(_) => []
    |   SVar(s) => [s]
    |   a SAdd b => vars(a) @ vars(b);

(* b *)

local
    fun ismember(_, [] ) = false
     |	ismember(a, b::bl) = (a=b) orelse ismember(a,bl);
    fun dublets( [] ) = false
     |  dublets( a::al ) = ismember(a,al) orelse dublets(al);
in
    fun legal( x ) = not( dublets(vars(x)) )
end;


(* c *)
type binding = string * udtr;
type bindingList = binding list;

(* bestem match: skab*udtr -> bindingList option *)
fun match( s: skab, u:udtr ) =
    case s of
	SConst(x) => ( 
	    case u of 
	      Const(y) => if (x=y) then SOME [] else NONE 
	    | _ => NONE )
      | SVar(x) => SOME [(x,u)]
      | sk1 SAdd sk2 => (
	    case u of 
	      u1 Add u2 => 
		let 
		    val bu1 = match(sk1,u1); 
		    val bu2 = match(sk2,u2) 
		in 
		    if (bu1=NONE) orelse (bu2=NONE) then NONE else SOME (valOf(bu1) @ valOf(bu2)) 
		end 
	      | _ => NONE )
      | _ => NONE;  
	
(* 
SConst(x) = Const(y) <=> x=y
SVar(s) = u => bindingList (s,u)
sk1 SAdd sk2 = u1 Add u2 <=> match(sk1,u1) and match(sk2,u2)
 
*)
























