(* Greatest common devisor *)

fun gcd(m,n) =
    if m = 0 then n
    else gcd(n mod m, m);

fun fact (0) = 1
    | fact (n) = fact(n-1)*n;

fun power(_, 0) = 1.0
  | power(x, m) = x * power(x,m-1);

fun fib (1) = 1
    | fib (2) = 1
    | fib (n) = fib(n-1) + fib(n-2);

(* opg. 1.1 *)
fun g(n) = n + 4;

(* opg 1.2 *)
load "Math";
fun h(x,y) = Math.sqrt(x*x + y*y);

(* opg 1.4 *)
fun sum (m,0) = m
    | sum(m,n) = sum(m,n-1) + (m + n);

(* opg 2.1 *)
exception BinError;

fun  bin (n,k) =
     if n < 0 orelse k < 0 orelse k > n then raise BinError
     else
       if k = 0 orelse n = k then 1
       else bin(n-1,k-1)+bin(n-1,k);
    
(* opg 2.3 *)

fun isIthChar(s, i, ch) =
    String.sub(s,i) = ch;


(* opg 2.8 laves i hnden, resultat aflses ved krsel *)
fun f(0,y) = y
    | f(x,y) = f(x-1, x * y);
(* a: " val  f =  fn: int * int -> int " *)
(* b: rekursion stopper ved x=o, s funkt. defineret for x>=0 *)
(* c:
 f(2,3)
  f(2-1, 2*3)
  f(1,6)
  f(1-1, 1*6)
  f(0,6) = 6       *)
(* d: y*x*(x-1)*(x-2)*..*(x-(x-1))
      or in other words: "y * x!"  *)




