(* opg 5.2 *)
fun rmodd( [] ) = []
  | rmodd( a::al ) = 
        if (a mod 2 = 1) then rmodd( al ) 
	else a::rmodd( al );

(* opg 5.4 
 * param n = max prime
 * return: all primes up to and including n
 *)

local

fun notDivisible( d, n ) = not (n mod d = 0); 

fun test (a,b,c) =
    if a<b then notDivisible(a,c) andalso test(a+1, b, c)
    else notDivisible(b, c);

fun isPrime(2) = true
    | isPrime(n) = test(2,n-1,n);



in

fun pr(0) = []
 | pr(1) = []
 | pr(2) = [2]
 | pr(n) = if isPrime(n) then n::pr(n-1) else pr(n-1);

end

(* opg 5.13 *)
(* a: *)
fun count(_, []) = 0
 |  count(n, a::al) = if a=n then 1+count(n,al) else count(n,al);

(* b: *)
fun insert(y, []) = [y]
 |  insert(y, a::al) = if y<a then y::a::al else a::insert(y, al);

(* c: *)
fun intersect(_,[]) = []
  | intersect([],_) = []
  | intersect(x::xl,y::yl) = if x < y then intersect(xl, y::yl)
			     else if x > y then intersect(x::xl, yl)
			     else  x::intersect(xl, yl);

(* d: *)
fun plus([],yl) = yl
 |  plus(xl,[]) = xl
 |  plus(x::xl,y::yl) = if x < y then x::plus(xl,y::yl)
    else if x > y then y::plus(x::xl,yl)
    else x::y::plus(xl,yl);

(* e: *)
fun minus([],yl) = []
 |  minus(xl, []) = xl
 |  minus(x::xl,y::yl) = if x < y then x::minus(xl,y::yl)
    else if x > y then minus(x::xl,yl)
    else minus(xl,yl);

(* opg 5.14 *)

fun rev([]) = []
 |  rev(x::xl) = rev(xl) @ [x];


fun revrev([]) = []
 |  revrev(x::xl) = revrev(xl) @ [rev(x)];





