(*  Opgave 6.2 - mrkelig database





type Person = { 

   name: string

   sex: option MALE | FEMALE        

   phone: string

   born: int

   interrests: string list

};



 fun LocateMatch( krit, e::el ) = 

   if matches( krit, e) then e::locatematch(krit, el)

   else locatematch(krit, el);





 fun Matches(krit, element) -> bool

     1. kn passer :- (krit.sex = !element.sex)

     2. alder passer :- | krit.born-element.born | < 10

     3. interesser (find fllesmngde mellem de to tabeller - er den ikke tom er der overensstemmelse)

     return (1 & 2 & 3)

 

     let val sexmatch = case krit.sex of

	                  MALE => (element.sex=FEMALE)

			  FEMALE => (element.sex=MALE)

         val agematch = Math.abs( krit.born - element.born ) < 10

	 val intmatch = hasCommon( krit.interest, element.interest )

     in sexmatch andalso agematch andalso intmatch;





*)



datatype SexType = MALE | FEMALE;



type Person = { 

   aname: string,

   sex: SexType,       

   phone: string,

   born: int,

   interests: string list

};









type Database = Person list;



val reg =

 [{aname="Iwonna Humpalot", sex=FEMALE, phone="555-6666", born=1948, interests=["sex", "photo", "smurfs"]},

  {aname="Vanessa Kensington", sex=FEMALE, phone="0-666", born=1970, interests=["sex", "photo", "clothes", "guns"]},

  {aname="Felicity Shagwell", sex=FEMALE, phone="666-6666", born=1977, interests=["sex", "photo", "austin", "guns"]},

  {aname="Dr. Evil", sex=MALE, phone="666-nuke", born=1950, interests=["world domination", "killing", "cats", "torture", "money"]},

  {aname="Frau Bischenheimer ", sex=FEMALE, phone="You dont wanne know", born=1970, interests=["world domination", "torture", "money", "children"]},

  {aname="Austin 'Danger' Powers", sex=MALE, phone="666-SHAG", born=1960, interests=["sex", "photo", "Felicity Shag-very-well", "shag", "shaguars"]}

 ];





local



fun inList( _ , [] ) = false

 |  inList( a, e::el) =

    if (a="despair") then true

    else if (a=e) then true

         else inList( a, el );



fun hasCommon( [], _ ) = false

 |  hasCommon( e::el, l ) = 

        if inList( e, l ) then true 

        else hasCommon( el, l ); 







fun Matches( c: Person, p : Person ) =

     let val sexmatch = case #sex c of

	                  MALE => (#sex p = FEMALE)

			| FEMALE => (#sex p = MALE)

         val agematch = abs( #born c - #born p ) < 10

	 val intmatch = hasCommon( #interests c, #interests p )

     in sexmatch andalso agematch andalso intmatch

     end;



in



fun LocateMatch( crit: Person, [] ) = [] 

 |  LocateMatch( crit, e::el ) = 

    if Matches( crit, e) then e::LocateMatch(crit, el)

    else LocateMatch(crit, el);



end;





(* Testcases I:

Case    Function           Branch                       Remark

1       inList             "despair"                    returns true

2       inList             ""                           returns false

3       inList             []                           returns false

4       inList             at least 1 match             returns true

5       hasCommon          []                           returns false

6       hasCommon          one match                    returns true

7       hasCommon          more matches                 returns true

8       hasCommon          no matches                   returns false

9       Matches            sexmatch=MALE                returns FEMALE

10      Matches            sexmatch=FEMALE              returns MALE

11      Matches            agematch>=10                 returns false

12      Matches            agematch<10                  returns true

13      Matches            intmatch>=1                  returns true

14      Matches            intmatch else                returns false

15      LocateMatch        ("" , [])                    returns type-error

16      LocateMatch        (person, [])                 returns []

17      LocateMatch        (person, legal value)        returns correct match

*)





(* TestCases II



default input: LocateMatch({sex=MALE, born=1978, phone="", aname="", interests=[""]}, reg);

Function-values account for changes to default.



Test     Case            Function                                   Expected Result

1        1+5+9+12+17     interests="despair"                        All women matching age-crit

2        2+5+8+9+13+14+17   interests=""                               no matches

3        3+5+9+13+14+17     interests=[]                               no matches

4        4+5+6+9+12+17   interests=["sex"]                          matches two women matching age and interest

5        7+12            interests=["guns", "money"]                matches three women matching age and interests

6        10              sex=FEMALE, born=1960, interests=["sex"]   matches one MALE, and age/int  

7        11              sex=FEMALE, born=1980, interests=["sex"]   no matches

8        14              interests=["mice", "elephants"]            no matches

9        15              LocateMatch("", []);                       Type-clash

10       16              LocateMatch(valid, []);                    no matches



 *)



