(*************************************)
(* Eksamensst jan.1998              *)
(*************************************)

(* Opgave 2 *)
datatype ctree = Leaf of char | Node of ctree * ctree;

(* Erklr findes: char * ctree -> bool *)
fun findes( c, Leaf(d) ) = (c=d)
 |  findes( c, Node(l,r) ) = findes(c,l) orelse findes(c,r);

datatype vh = V | H;
exception EUnknownChar

fun encodeChar t ch = 
    case t of
	Leaf(c) => if (c=ch) then [] else raise EUnknownChar
      | Node(l,r) => if findes(ch,l) then V::(encodeChar l ch ) else if findes(ch,r) then H::( encodeChar r ch ) else []

fun encode t [] = []
 |  encode t (ch::chl) = (encodeChar t ch) @ (encode t chl);


val testtree = Node( Node( Leaf(#"a"), Leaf(#"b") ), Node( Leaf(#"c"), Leaf(#"d")));
