compile "Curves.sig";
compile "Curves.sml";
load "Curves";
open Curves;


DrawOneCurve Hilbert (4, "hilbert4.ps");
DrawOneCurve Sierpinski (6, "sierpinski6.ps");
val sip = SmartRec Sierpinski (2);
val sier = Trans (sip, (0.0, 3.0) );
toPostscript( Draw(sier), "sier.ps");
